local myMod = ...

-- Register all shoemaker building parts and their properties
myMod:dofile("scripts/building_settings.lua")

local myBuilding =
{
	DataType = "BUILDING",
	Id = "TANNERY_BUILDING",
	Name = "TANNERY_NAME",
	Description = "TANNERY_DESC",
	BuildingType = "GENERAL",
	VillagerRequired = { Status = "COMMONER", Quantity = 20 }
}
--Check which version is been used
if (foundation.getGameVersion == nil or version.cmp(foundation.getGameVersion(), "1.6") < 0) then
	myBuilding.BuildingPartSetList = {
		{
			Name = "GENERAL",
			BuildingPartList = { "TANNERY_PART" }
		}
	}
	_DefinitionOfBuildingZone = {
		Polygon = polygon.createRectangle({ 10, 7 })
	}
else
	myBuilding.AssetCoreBuildingPart = "TANNERY_PART"
	_DefinitionOfBuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createRectangle( {10, 7} ),
				Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
end
 
myMod:register(myBuilding)

myMod:register({
	DataType = "BUILDING_PART",
	Id = "TANNERY_PART",
	--Description = "",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TANNERY"
	},
	BuildingZone = _DefinitionOfBuildingZone,
	--BuildingZoneData = {
	--	Polygon = polygon.createRectangle({ 10, 7 })
	--},
	ConstructionVisual = "PREFAB_TANNERY_CONSTRUCTION",
	--DesirabilityModifiers = {"DESIRABILITY_EFFECT_TYPE"},
	BuildingFunction = "TANNERY_FUNCTION",
	--BuildingFunction = "TANNERY_ASSIGNABLE_FUNCTION",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 5 }
		},
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 10 },
			{ Resource = "PLANK", Quantity = 6 },
			{ Resource = "TOOL", Quantity = 4 }
		}
	}
})

-- Add a assignable function to the building
myMod:register({
		DataType = "BUILDING_FUNCTION_ASSIGNABLE",
                Id = "TANNERY_FUNCTION",
                AuthorizedFunctionList = "TANNERY_FUNCTION_LIST"
})
--Add a list with different functions
myMod:register({
		DataType = "BUILDING_FUNCTION_LIST",
                Id = "TANNERY_FUNCTION_LIST",
                AssetFunctionList = {
                        "TANNERY_FUNCTION_BOAR_TO_LEATHER"--,
                        --"SMOKE_HOUSE_V3_BOAR_FUNCTION"
                }
})

-- Building function boar to leather
myMod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "TANNERY_FUNCTION_BOAR_TO_LEATHER",
	Name = "TANNERY_FUNCTION_BOAR_TO_LEATHER_NAME",
    WorkerCapacity = 2,
	RelatedJob = { Job = "TANNER", Behavior = "WORK_BEHAVIOR" },
	InputInventoryCapacity = {{ Resource = "BOAR", Quantity = 20 }},
	ResourceListNeeded = {{ Resource = "BOAR", Quantity = 2 }},
	ResourceProduced = {{ Resource = "LEATHER", Quantity = 4 }}	
})